##
##  classgen.spec -- OpenPKG RPM Package Specification
##  Copyright (c) 2000-2025 OpenPKG Project <http://openpkg.org/>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package information
Name:         classgen
Summary:      Java Class Generation
URL:          http://classgen.sourceforge.net/
Vendor:       G. Klein, F. Deissenboeck, S. Winter
Packager:     OpenPKG Project
Distribution: OpenPKG Community
Class:        EVAL
Group:        CompilerCompiler
License:      GPL
Version:      1.4
Release:      20080101

#   list of sources
Source0:      http://classgen.sourceforge.net/downloads/classgen-%{version}-bin.tar.gz

#   build information
BuildPreReq:  OpenPKG, openpkg >= 20160101
PreReq:       OpenPKG, openpkg >= 20160101, java, cup

%description
    Classgen is a 100% Java, platform-independent class generator.
    Though it was designed with compiler design (and abstract syntax
    tree generation) in mind its very compact and flexible specification
    language allows to generate classes for all purposes. For the
    compiler designer it offers some more extremely useful features. It
    has built in support for the visitor design pattern and gets along
    perfectly with the scanner generator JFlex and the parser generator
    CUP.

%track
    prog classgen = {
        version   = %{version}
        url       = http://classgen.sourceforge.net/download.html
        regex     = classgen-(__VER__)-bin\.tar\.gz
    }

%prep
    %setup -q

%build
    ( echo "#!/bin/sh"
      echo "exec %{l_prefix}/bin/java \\%{l_nil}"
      echo "    -cp %{l_prefix}/libexec/classgen/classgen.jar:%{l_prefix}/libexec/cup/cup.jar \\%{l_nil}"
      echo "    classgen.Main \${1+\"\$@\"}"
    ) >classgen

%install
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix}/bin \
        $RPM_BUILD_ROOT%{l_prefix}/libexec/classgen \
        $RPM_BUILD_ROOT%{l_prefix}/lib/classgen \
        $RPM_BUILD_ROOT%{l_prefix}/share/classgen
    %{l_shtool} install -c -m 755 %{l_value -s -a} \
        classgen $RPM_BUILD_ROOT%{l_prefix}/bin/
    %{l_shtool} install -c -m 644 \
        lib/classgen.jar $RPM_BUILD_ROOT%{l_prefix}/libexec/classgen/
    %{l_shtool} install -c -m 644 \
        lib/classgen-framework.jar $RPM_BUILD_ROOT%{l_prefix}/lib/classgen/
    cp -rp docs/* $RPM_BUILD_ROOT%{l_prefix}/share/classgen/
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT %{l_files_std}

%files -f files

%clean

